const Influx = require('influx');
const mqtt = require('mqtt');
var mqtt_client  = mqtt.connect('mqtt://localhost:1883')

mqtt_client.subscribe("measurement");

mqtt_client.on('message', function (topic, message) {
  const obj = JSON.parse(message);
  influx.writePoints([
      {
        measurement: 'air_heritage',
        fields: {temperature: obj.temperature, humidity: obj.humidity, pressure: obj.pressure, co2: 0.0},
		tags: {
          id: obj.id
        }		  
      }
    ]).catch(err => {
      console.log(`Error saving data to InfluxDB! ${err.stack}`)
    })  
  console.log(message.toString());
})

const influx = new Influx.InfluxDB({
  host: 'localhost',
  database: 'iotsensors',
  schema: [
    {
      measurement: 'air_heritage',
      fields: {
		//id: Influx.FieldType.STRING,
		//sequence: Influx.FieldType.INTEGER,
        temperature: Influx.FieldType.FLOAT,
        humidity: Influx.FieldType.FLOAT,
        pressure: Influx.FieldType.FLOAT,
        co2: Influx.FieldType.FLOAT
      },
      tags: [
        'id'
      ]
    }
  ]
})

influx.getDatabaseNames()
  .then(names => {
    if (!names.includes('iotsensors')) {
	  console.log(`Created Influx database!`);
      return influx.createDatabase('iotsensors');
    }
	else{
		  console.log(`Database yet present`);
		}
  })
  .catch(err => {
    console.log(`Error creating Influx database!`);
  })



/*
influx.query(`
    select * from air_heritage
    order by time desc
    limit 10
  `).then(result => {
  console.log(result)
  }).catch(err => {
    console.log(err.stack)
  })
*/

